<template>
  <div>
    <h2>{{ raceModel.name }}</h2>
    <p>{{ startInstant }}</p>
    <div v-if="ponies">
      <Pony v-for="pony of ponies" :key="pony.id" :ponyModel="pony" @selected="changeColor(pony)" />
    </div>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType } from 'vue';
import { RaceModel } from '@/models/RaceModel';
import { PonyModel } from '@/models/PonyModel';
import { getRandomColor } from '@/utils/index';
import { getPonies } from '@/services/api';
import Pony from '@/components/Pony.vue';

export default defineComponent({
  name: 'Race',

  components: {
    Pony
  },

  props: {
    raceModel: {
      type: Object as PropType<RaceModel>,
      required: true
    }
  },

  data() {
    return {
      ponies: []
    };
  },

  mounted() {
    this.fetchPonies();
  },

  methods: {
    fetchPonies() {
      return getPonies(this.raceModel.id).then(res => (this.ponies = res));
    },
    changeColor(pony: PonyModel) {
      pony.color = getRandomColor();
    }
  }
});
</script>
